' Schnelle 3D-Grafik

' Datentyp fr Vektoren
TYPE Vektor
  x AS SINGLE
  y AS SINGLE
  z AS SINGLE
END TYPE

DECLARE SUB GenerierePyramide (gm AS Vektor, h AS Vektor, e1 AS Vektor, n%, Fa%)
DECLARE SUB ResetSpeicher ()
DECLARE SUB Umrechnen ()
DECLARE SUB ZeichneGrafik ()
DECLARE SUB FuegeKnotenEin (p1 AS Vektor)
DECLARE SUB FuegeVerbindinfEin (knr%)
DECLARE SUB RotiereVektor (b AS Vektor, a AS Vektor, w!, r AS Vektor)
DECLARE SUB VektorAdd (v1 AS Vektor, v2 AS Vektor, su AS Vektor)
DECLARE SUB VektorSub (v1 AS Vektor, v2 AS Vektor, di AS Vektor)
DECLARE SUB VektorSkalMult (sk!, v AS Vektor, pr AS Vektor)
DECLARE SUB Einheitsvektor (v1 AS Vektor, r AS Vektor)
DECLARE FUNCTION Betrag! (v AS Vektor)
DECLARE SUB Kreuz (v1 AS Vektor, v2 AS Vektor, a AS Vektor)
DECLARE FUNCTION Skalar! (a AS Vektor, b AS Vektor)
DECLARE SUB DreheAnsicht (a AS Vektor, w!)

CONST Schritt! = .2

DIM SHARED pi!
pi! = 4! * ATN(1!)

DIM SHARED p(20 TO 60) AS Vektor, pObs(20 TO 60) AS Vektor, Ind%(60), lK%, ip%
DIM SHARED uo AS Vektor, vo AS Vektor, wo AS Vektor
DIM SHARED HAchse AS Vektor, VAchse AS Vektor

DIM Demoachse AS Vektor

' Drehachsen fr Tastatur definieren
HAchse.x = 1!: HAchse.y = 0!: HAchse.z = 0!
VAchse.x = 0!: VAchse.y = 1!: VAchse.z = 0!

' Am Anfang noch nichts verdreht, d.h. Einheitsmatrix!

uo.x = 1!: uo.y = 0!: uo.z = 0!
vo.x = 0!: vo.y = 1!: vo.z = 0!
wo.x = 0!: wo.y = 0!: wo.z = 1!

' Daten fr die erste Pyramide
DIM lage1 AS Vektor, hoehe1 AS Vektor, ecke1 AS Vektor
lage1.x = 0!: lage1.y = 0!: lage1.z = 0!
hoehe1.x = 0!: hoehe1.y = 1!: hoehe1.z = 0!
ecke1.x = .5: ecke1.y = 0!: ecke1.z = .5
n1% = 4: Farbe1% = 14

' Daten fr die zweite Pyramide
DIM lage2 AS Vektor, hoehe2 AS Vektor, ecke2 AS Vektor
lage2.x = -1.5: lage2.y = -.3: lage2.z = .4
hoehe2.x = .4: hoehe2.y = 1.5: hoehe2.z = .1
ecke2.x = .5: ecke2.y = 0!: ecke2.z = .5
n2% = 11: Farbe2% = 12

' Daten fr die dritte Pyramide
DIM lage3 AS Vektor, hoehe3 AS Vektor, ecke3 AS Vektor
lage3.x = 1.7: lage3.y = .6: lage3.z = .6
hoehe3.x = .1: hoehe3.y = -.2: hoehe3.z = -1.6
ecke3.x = .7: ecke3.y = .3: ecke3.z = 0!
n3% = 5: Farbe3% = 9

' Start Demoprogramm : Aus Geschwindigkeitsgrnden und wegen
' der Double-Buffering-Technik im EGA-Modus, niedrige Auflsung

SCREEN 7
WINDOW (-4!, -3!)-(4!, 3!) ' Bildverhltnis 4:3

ResetSpeicher ' Speicher leeren

GenerierePyramide lage1, hoehe1, ecke1, n1%, Farbe1% ' Pyramiden generieren
GenerierePyramide lage2, hoehe2, ecke2, n2%, Farbe2%
GenerierePyramide lage3, hoehe3, ecke3, n3%, Farbe3%

PFlag% = 0 ' Flag, welche Seite momentan sichtbar

GOSUB Zeichnen
DO
  GOSUB Zeichnen
  DO
    t$ = INKEY$
  LOOP WHILE t$ = ""
  SELECT CASE t$
  CASE CHR$(0) + "H"
    DreheAnsicht HAchse, Schritt!
  CASE CHR$(0) + "P"
    DreheAnsicht HAchse, -Schritt!
  CASE CHR$(0) + "K"
    DreheAnsicht VAchse, Schritt!
  CASE CHR$(0) + "M"
    DreheAnsicht VAchse, -Schritt!
  CASE "d", "D"
    ' Demo!
    Demoachse.z = 0!
    w! = -50!
    DO
      w! = w! + .043
      Demoachse.x = COS(w!)
      Demoachse.y = SIN(w!)
      DreheAnsicht Demoachse, .1
      GOSUB Zeichnen
    LOOP WHILE INKEY$ = ""
  END SELECT
LOOP UNTIL t$ = CHR$(27)

SCREEN 0: WIDTH 80, 25 ' wieder alles zurcksetzen
END

Zeichnen:
PFlag% = 1 - PFlag%
CLS
Umrechnen
ZeichneGrafik
SCREEN , , 1 - PFlag%, PFlag% ' Arbeits- und Anzeigeseite tauschen
RETURN

' Vektorbetrag bestimmen
FUNCTION Betrag! (v AS Vektor)
  Betrag! = SQR(v.x * v.x + v.y * v.y + v.z * v.z)
END FUNCTION

SUB DreheAnsicht (a AS Vektor, w!)
  DIM h AS Vektor
  RotiereVektor uo, a, w!, h: uo = h
  RotiereVektor vo, a, w!, h: vo = h
  RotiereVektor wo, a, w!, h: wo = h
END SUB

' Einheitsvektor bestimmen
SUB Einheitsvektor (v1 AS Vektor, r AS Vektor)
  l = Betrag(v1)
  r.x = v1.x / l
  r.y = v1.y / l
  r.z = v1.z / l
END SUB

' Knotenpunkt einfgen
SUB FuegeKnotenEin (p1 AS Vektor)
  lK% = lK% + 1
  p(lK%) = p1
END SUB

' Knotenverbindungsinformation/Farbe einfgen
SUB FuegeVerbindinfEin (knr%)
  Ind%(ip%) = knr%
  ip% = ip% + 1
END SUB

' Pyramide generieren
SUB GenerierePyramide (gm AS Vektor, h AS Vektor, e1 AS Vektor, n%, Fa%)
  DIM pkt AS Vektor, hv AS Vektor
  VektorAdd gm, h, pkt
  FuegeKnotenEin pkt ' Spitze einfgen
  FuegeVerbindinfEin Fa% ' Farbe einfgen
  sw! = 2! * pi! / CSNG(n%)
  hz% = lK%
  FuegeVerbindinfEin -hz% - 2
  FuegeVerbindinfEin hz%
  FOR i% = 1 TO n%
    RotiereVektor e1, h, CSNG(i%) * sw!, hv
    VektorAdd gm, hv, pkt
    FuegeKnotenEin pkt ' Ecke einfgen
    FuegeVerbindinfEin hz% + i%
  NEXT i%
  FuegeVerbindinfEin hz% + 1
  ' Verbindungsinformation fr Drahtmodell konzipiert
  FOR i% = 3 TO n%
    IF i% AND 1 THEN
      FuegeVerbindinfEin -hz% - i%
      FuegeVerbindinfEin hz%
    ELSE
      FuegeVerbindinfEin hz% + i%
    END IF
  NEXT i%
END SUB

' Kreuzprodukt berechnen (in BASIC nicht als Funktion mglich
SUB Kreuz (v1 AS Vektor, v2 AS Vektor, a AS Vektor)
  a.x = v1.y * v2.z - v1.z * v2.y
  a.y = v1.z * v2.x - v1.x * v2.z
  a.z = v1.x * v2.y - v1.y * v2.x
END SUB

' 3D-Speicher zurcksetzen
SUB ResetSpeicher
  lK% = 19: ip% = 0
END SUB

' Vektor b um Drehachsenvektor a um Winkel w drehen
' r = Resultatvektor
SUB RotiereVektor (b AS Vektor, a AS Vektor, wi!, r AS Vektor)
  ' Variablendeklarationen
  DIM u AS Vektor, v AS Vektor, w AS Vektor, h AS Vektor, h2 AS Vektor
  VektorSkalMult Skalar(b, a) / Skalar(a, a), a, w
  VektorSub b, w, h: VektorSkalMult COS(wi!), h, u
  Einheitsvektor a, h: Kreuz b, h, h2: VektorSkalMult SIN(wi!), h2, v
  VektorAdd u, v, h: VektorAdd h, w, r
END SUB

' Skalarprodukt bestimmen
FUNCTION Skalar! (a AS Vektor, b AS Vektor)
  Skalar! = a.x * b.x + a.y * b.y + a.z * b.z
END FUNCTION

' Umrechnen der absoluten Koordinaten in Bildschirmkoordinaten
SUB Umrechnen
  FOR i% = 20 TO lK%
    pObs(i%).x = uo.x * p(i%).x + vo.x * p(i%).y + wo.x * p(i%).z
    pObs(i%).y = uo.y * p(i%).x + vo.y * p(i%).y + wo.y * p(i%).z
    'pObs(i%).z = uo.z * p(i%).x + vo.z * p(i%).y + wo.z * p(i%).z
  NEXT i%
END SUB

' Vektorsumme bestimmen
SUB VektorAdd (v1 AS Vektor, v2 AS Vektor, su AS Vektor)
  su.x = v1.x + v2.x
  su.y = v1.y + v2.y
  su.z = v1.z + v2.z
END SUB

' Vektor mit Skalar multiplikation
SUB VektorSkalMult (sk!, v AS Vektor, pr AS Vektor)
  pr.x = sk! * v.x
  pr.y = sk! * v.y
  pr.z = sk! * v.z
END SUB

' Vektorensubtraktion
SUB VektorSub (v1 AS Vektor, v2 AS Vektor, di AS Vektor)
 di.x = v1.x - v2.x
 di.y = v1.y - v2.y
 di.z = v1.z - v2.z
END SUB

SUB ZeichneGrafik
  FOR i% = 0 TO ip% - 1
    SELECT CASE Ind%(i%)
    CASE IS > 19
      LINE -(pObs(Ind%(i%)).x, pObs(Ind%(i%)).y)
    CASE IS > -1
      COLOR Ind%(i%)
    CASE ELSE
      PSET (pObs(-Ind%(i%)).x, pObs(-Ind%(i%)).y)
    END SELECT
  NEXT i%
END SUB

